commit 6ced00d53d91ea429948b34e6600b4633f962030
Author: Sergei Trofimovich <siarheit@google.com>
Date:   Tue Aug 16 12:35:07 2022 +0100

    driver: fix environ corruption after putenv() [PR106624]
    
    The bug appeared afte r13-2010-g1270ccda70ca09 "Factor out
    jobserver_active_p" slightly changed `putenv()` use from allocating
    to non-allocating:
    
        -xputenv (concat ("MAKEFLAGS=", dup, NULL));
        +xputenv (jinfo.skipped_makeflags.c_str ());
    
    `xputenv()` (and `putenv()`) don't copy strings and only store the
    pointer in the `environ` global table. As a result `environ` got
    corrupted as soon as `jinfo.skipped_makeflags` store got deallocated.
    
    This started causing bootstrap crashes in `execv()` calls:
    
        xgcc: fatal error: cannot execute '/build/build/./prev-gcc/collect2': execv: Bad address
    
    The change restores memory allocation for `xputenv()` argument.
    
    gcc/
    
            PR driver/106624
            * gcc.c (driver::detect_jobserver): Allocate storage xputenv()
            argument using xstrdup().
    
    (cherry picked from commit 2b403297b111c990c331b5bbb6165b061ad2259b)

diff --git a/gcc/gcc.c b/gcc/gcc.c
index ed7099c2a6d..6517d9935dc 100644
--- a/gcc/gcc.c
+++ b/gcc/gcc.c
@@ -8403,7 +8403,7 @@ driver::detect_jobserver () const
 {
   jobserver_info jinfo;
   if (!jinfo.is_active && !jinfo.skipped_makeflags.empty ())
-    xputenv (jinfo.skipped_makeflags.c_str ());
+    xputenv (xstrdup (jinfo.skipped_makeflags.c_str ()));
 }
 
 /* Determine what the exit code of the driver should be.  */

